import sys
import os
import numpy as np

def processLog(t1, t2, t3, log):
	fi = open(log, "r")
	f1 = 0
	f2 = 0
	f3 = 0
	for s in fi:
		ls = s.split()
		if len(ls)==0: continue
		if ls[0]=="Optimized": 
			f2 = 1
			continue
		if f2==1:	
			t2.append(float(ls[-2]))
			f2 = 0
			continue
		if ls[0]=="Slow": 
			f1 = 1
			continue
		if f1==1:	
			t1.append(float(ls[-2]))
			f1 = 0
			continue
		if ls[0]=="Fast": 
			f3 = 1
			continue
		if f3==1:	
			t3.append(float(ls[-2]))
			f3 = 0
			continue			

nAtoms = []
for i in (10000,20000,50000,100000):
	nAtoms.append(i)

nModes = []
for i in range(5, 55, 5):
	nModes.append(i)

nPoses = []
nPoses = [100]

rmsd = 40

nStat = 10

if not (os.path.isdir("./test")):
        os.system("mkdir ./test")

print "%10s %10s %10s %16s %16s %16s %16s %16s %16s %16s %16s %16s %16s\n" % ("nAtoms", "nModes", "nPoses", "Mean_t1", "Std_t1", "Mean_t2", "Std_t2", "Mean_t3", "Std_t3", "Mean_p1", "Std_p1", "Mean_p2", "Std_p2")
for a in nAtoms:
	for m in nModes:
		for p in nPoses:
			t1 = []
			t2 = []
			t3 = []
			for i in range(0, nStat):
				of = "./test/test_%d_%d_%d_%d.log" % (a, m, p, i)
				cmd = "./clustering_args %d %d %d %d > %s" % (a, m, p, rmsd, of)
				os.system(cmd) 
				processLog(t1, t2, t3, of)
			profit1 = []
			profit2 = []
			for i, v in enumerate(t3):
				profit1.append(t1[i]/v)
				profit2.append(t2[i]/v)
			print "%10d %10d %10d %16.3f %16.3f %16.3f %16.3f %16.3f %16.3f %16.3f %16.3f %16.3f %16.3f" % (a, m, p, np.mean(t1), np.std(t1), np.mean(t2), np.std(t2), np.mean(t3), np.std(t3), np.mean(profit1), np.std(profit1), np.mean(profit2), np.std(profit2))

